/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package controlador;

import com.opensymphony.xwork2.ActionContext;
import com.opensymphony.xwork2.ActionSupport;
import dao.CategoriaDAO;
import dao.ProductoDAO;
import entidad.Categoria;
import entidad.Producto;
import java.io.File;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import javax.swing.JOptionPane;

/**
 *
 * @author Jose Luis
 */
public class CategoriaControlador extends ActionSupport {

    private CategoriaDAO categoriaDAO = new CategoriaDAO();
    private Categoria categoria = new Categoria();
    private String msg = null;
    private File archivo;
    private String archivoContentType;
    private String archivoFileName;
    private String imagen;
    private String nomCategoria;
    private int idCategoria;

    public String administrarCatalogo() {
        return "OK";
    }

    public String formularioRegistroCategoria() {
        return "OK";
    }

    public String cargaArchivo() {

        try {

            imagen = archivoFileName;

        } catch (Exception e) {
            e.printStackTrace();
        }
        return "success";
    }

    public String cargaArchivoModificado() {
        imagen = archivoFileName;
        return "success";
    }

    public String cargarCategoriasIndex() {

        Map<String, Object> session = ActionContext.getContext().getSession();
        List<Categoria> categorias = new ArrayList();
        List<Categoria> categoriasTemp = new ArrayList();
        List<Producto> productosAleatorios = new ArrayList();

        categorias = CategoriaDAO.obtenListaCategorias();
        ProductoDAO productoDAO = new ProductoDAO();

        Iterator iter = categorias.iterator();
        while (iter.hasNext()) {
            Categoria categoria = new Categoria();
            categoria = (Categoria) iter.next();
            categoria.setProductos(productoDAO.obtenListaProductos(categoria.getIdCategoria()));
            categoriasTemp.add(categoria);
        }
        session.put("listaCategoriasActualizada", categoriasTemp);
        productosAleatorios = productoDAO.obtenProductosAleatorios();
        session.put("productosAleatorios", productosAleatorios);
        session.put("estanActualizadas", true);

        return ("OK");
    }

    public List<Categoria> cargarCategoriasProductosBBDD() {

        List<Categoria> categorias = new ArrayList();
        List<Categoria> categoriasTemp = new ArrayList();

        categorias = CategoriaDAO.obtenListaCategorias();
        ProductoDAO productoDAO = new ProductoDAO();

        Iterator iter = categorias.iterator();
        while (iter.hasNext()) {
            Categoria categoria = new Categoria();
            categoria = (Categoria) iter.next();
            categoria.setProductos(productoDAO.obtenListaProductos(categoria.getIdCategoria()));
            categoriasTemp.add(categoria);
        }

        return (categoriasTemp);
    }

    public String nuevaCategoria() {

        if (categoria.getNombreCategoria().isEmpty() || categoria.getImagen().isEmpty()) {
            msg = "Por favor, rellene todos los campos";
            return ("KO");
        }

        Map<String, Object> session = ActionContext.getContext().getSession();

        if (categoriaDAO.insertarCategoria(categoria)) {
            msg = "La Categoria ha sido Insertado Correctamente.";

            session.put("listaCategoriasActualizada", this.cargarCategoriasProductosBBDD());

            return "OK";
        } else {
            msg = "Ha Ocurrido un Error al Insertar la Categoria.";
            return "KO";
        }
    }

    public String administrarCategoria() {
        Map<String, Object> session = ActionContext.getContext().getSession();

        List<Categoria> listaCategorias = (List<Categoria>) session.get("listaCategoriasActualizada");
        Iterator iter = listaCategorias.iterator();

        while (iter.hasNext()) {
            Categoria categoriaTemp = new Categoria();
            categoriaTemp = (Categoria) iter.next();

            if (categoriaTemp.getIdCategoria() == idCategoria) {
                session.put("categoriaTratada", categoriaTemp);
            }
        }

        return ("OK");
    }

    public String modificarCategoria() {

        if (categoria.getNombreCategoria().isEmpty() || categoria.getImagen().isEmpty()) {
            msg = "Por favor, rellene todos los campos";
            return ("KO");
        }

        Map<String, Object> session = ActionContext.getContext().getSession();

        Categoria categoriaTratada = (Categoria) session.get("categoriaTratada");

        categoriaTratada.setImagen(categoria.getImagen());
        categoriaTratada.setNombreCategoria(categoria.getNombreCategoria());
        categoriaDAO.actualizaCategoria(categoriaTratada);

        session.put("listaCategoriasActualizada", this.cargarCategoriasProductosBBDD());
        msg = "La categoria ha sido modificada correctamente";

        return ("OK");

    }

    public String mostrarProductosCategoria() {
        Map<String, Object> session = ActionContext.getContext().getSession();

        List<Categoria> categorias = (List<Categoria>) session.get("listaCategoriasActualizada");

        Iterator iter = categorias.iterator();
        while (iter.hasNext()) {
            Categoria categoriaTemp = (Categoria) iter.next();

            if (categoriaTemp.getIdCategoria() == idCategoria) {
                session.put("categoriaTratada", categoriaTemp);
            }

        }
        return ("OK");
    }

    public String eliminarCategoria() {
        int seleccion = JOptionPane.showConfirmDialog(null, "¿Desea eliminar la categoria y sus productos del catalogo?", "Confirmar borrado", JOptionPane.YES_NO_CANCEL_OPTION, JOptionPane.QUESTION_MESSAGE);
        //0 si
        //1 no
        //2 cancelar

        if (seleccion == 0) {
            Map<String, Object> session = ActionContext.getContext().getSession();

            Categoria categoria = (Categoria) session.get("categoriaTratada");

            categoriaDAO.eliminaCategoria(categoria);
            ProductoDAO productoDAO = new ProductoDAO();
            //recupero sus productos
            List<Producto> productos = productoDAO.obtenListaProductos(categoria.getIdCategoria());
            Iterator iter = productos.iterator();
            //recorro los productos y los elimino
            while (iter.hasNext()) {
                Producto producto = (Producto) iter.next();
                productoDAO.eliminaProducto(producto);
            }

            session.put("listaCategoriasActualizada", this.cargarCategoriasProductosBBDD());
            msg = "La categoria y sus productos se han eliminado correctamente del catalogo.";

            return "OK";
        } else {
            return "NOBORRAR";
        }
    }

    public String getArchivoContentType() {
        return archivoContentType;
    }

    public void setArchivoContentType(String archivoContentType) {
        this.archivoContentType = archivoContentType;
    }

    public void setArchivoFileName(String archivoFileName) {
        this.archivoFileName = archivoFileName;
    }

    public String getNombre() {
        return archivoFileName;
    }

    public String getRuta() {
        return archivo.getAbsolutePath();
    }

    public void setArchivo(File archivo) {
        this.archivo = archivo;
    }

    public String getImagen() {
        return imagen;
    }

    public File getArchivo() {
        return archivo;
    }

    public String getArchivoFileName() {
        return archivoFileName;
    }

    public void setNomCategoria(String nomCategoria) {
        this.nomCategoria = nomCategoria;
    }

    public String getNomCategoria() {
        return this.nomCategoria;
    }

    public Categoria getCategoria() {
        return categoria;
    }

    public void setCategoria(Categoria categoria) {
        this.categoria = categoria;
    }

    public String getMsg() {
        return msg;
    }

    public void setMsg(String msg) {
        this.msg = msg;
    }

    public void setIdCategoria(int idCategoria) {
        this.idCategoria = idCategoria;
    }

    public int getIdCategoria() {
        return this.idCategoria;
    }
}
