/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package controlador;

import com.opensymphony.xwork2.ActionContext;
import com.opensymphony.xwork2.ActionSupport;
import dao.CompraDAO;
import dao.MetodoPagoDAO;
import dao.ProductoDAO;
import dao.ProductosCompraDAO;
import entidad.Compra;
import entidad.MetodoPago;
import entidad.Producto;
import entidad.ProductosCompra;
import entidad.Usuario;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import javax.swing.JOptionPane;

/**
 *
 * @author Jose Luis
 */
public class CompraControlador extends ActionSupport {

    private CompraDAO compraDAO = new CompraDAO();
    private ProductosCompraDAO productosCompraDAO = new ProductosCompraDAO();
    private MetodoPagoDAO metodoPagoDAO = new MetodoPagoDAO();
    private int idProducto;
    private float precioTotal;
    private List<String> estados = new ArrayList<String>() {
        {
            add("Esperando Pago");
            add("Tramitándose (Pago Pendiente)");
            add("Tramitándose (Pagado)");
            add("Enviado");
            add("Entregado");
        }
    };
    private String estado;
    private int idCompra;
    private String msg = "";
    private boolean modificado = false;

    public String verCarrito() {
        Map<String, Object> session = ActionContext.getContext().getSession();

        if (session.get("carrito") == null) {
            Compra compraTemp = new Compra();
            session.put("carrito", compraTemp);
        }

        return "OK";
    }

    public String insertarCarrito() {

        Map<String, Object> session = ActionContext.getContext().getSession();
        ProductoDAO productoDAO = new ProductoDAO();
        Producto producto = productoDAO.obtenProducto(idProducto);

        ProductosCompra productosCompra = new ProductosCompra(idProducto, 0, 1, producto);
        Compra compraTemp = new Compra();

        if (session.get("carrito") == null) {

            compraTemp.addProductosCompra(productosCompra);
        } else {
            compraTemp = (Compra) session.get("carrito");
            //Comprobar si el carrito ya tiene el producto añadido
            for (int i = 0; i < compraTemp.getProductosCompra().size(); i++) {
                if (compraTemp.getProductosCompra().get(i).getProducto().getIdProducto() == idProducto) {
                    msg = "Este producto ya esta esta añadido al carrito de compra.";
                    return "KO";
                }
            }
            compraTemp.addProductosCompra(productosCompra);
        }
        session.put("carrito", compraTemp);

        return "OK";
    }

    public String sumarCantidad() {
        Map<String, Object> session = ActionContext.getContext().getSession();

        Compra compraTemp = (Compra) session.get("carrito");
        ProductoDAO productoDAO = new ProductoDAO();
        List<ProductosCompra> listaProductosCompra = compraTemp.getProductosCompra();
        List<ProductosCompra> listaProductosCompraTemp = new ArrayList();

        Iterator iter = listaProductosCompra.iterator();

        while (iter.hasNext()) {
            ProductosCompra productosCompraTemp = (ProductosCompra) iter.next();
            //Recojo el stock de la base de datos por si ha sufrido algun cambio mientras se compraba
            Producto productoStock = productoDAO.obtenProducto(productosCompraTemp.getProducto().getIdProducto());
            if (productosCompraTemp.getProducto().getIdProducto() == idProducto) {
                //Compruebo si se ha llegado al limite del stock del producto

                if (productosCompraTemp.getCantidad() < productoStock.getStock()) {
                    productosCompraTemp.setCantidad(productosCompraTemp.getCantidad() + 1);
                } else {
                    //Si la cantidad es igual al stock (ha llegado al maximo del stock)
                    //o si es mayor que el stock(otro cliente ha comprado dicho producto), dejo el stock del producto a 0 y se lo indico al cliente
                    if (productosCompraTemp.getCantidad() == productoStock.getStock()) {
                        msg = "No hay disponibles mas existencias del producto.";
                    } else {
                        msg = "El stock de los productos de su carrito ha sido modificado mientras usted hacia su compra. Se ha modificado la cantidad de dichos productos a 0, por favor seleccione una nueva cantidad. Disculpe las molestias.";
                        productosCompraTemp.setCantidad(0);
                        modificado = true;
                    }
                }
            }
            listaProductosCompraTemp.add(productosCompraTemp);
        }
        compraTemp.setProductosCompra(listaProductosCompraTemp);
        session.put("carrito", compraTemp);

        if (modificado) {
            return "OK";
        } else {
            return "KO";
        }
    }

    public String restarCantidad() {
        Map<String, Object> session = ActionContext.getContext().getSession();

        Compra compraTemp = (Compra) session.get("carrito");
        ProductoDAO productoDAO = new ProductoDAO();
        List<ProductosCompra> listaProductosCompra = compraTemp.getProductosCompra();
        List<ProductosCompra> listaProductosCompraTemp = new ArrayList();

        Iterator iter = listaProductosCompra.iterator();

        while (iter.hasNext()) {
            ProductosCompra productosCompraTemp = (ProductosCompra) iter.next();
            //Recojo el stock de la base de datos por si ha sufrido algun cambio mientras se compraba
            Producto productoStock = productoDAO.obtenProducto(productosCompraTemp.getProducto().getIdProducto());

            if (productosCompraTemp.getProducto().getIdProducto() == idProducto) {

                //Compruebo si la cantidad es mayor al stock, por tanto otro cliente ya ha comprado unidades del producto
                if (productosCompraTemp.getCantidad() > productoStock.getStock()) {
                    msg = "El stock de los productos de su carrito ha sido modificado mientras usted hacia su compra. Se ha modificado la cantidad de dichos productos a 0, por favor seleccione una nueva cantidad. Disculpe las molestias.";
                    productosCompraTemp.setCantidad(0);
                    modificado = true;
                } else {
                    productosCompraTemp.setCantidad(productosCompraTemp.getCantidad() - 1);
                }
            }
            listaProductosCompraTemp.add(productosCompraTemp);
        }
        compraTemp.setProductosCompra(listaProductosCompraTemp);
        session.put("carrito", compraTemp);

        if (modificado) {
            return "OK";
        } else {
            return "KO";
        }
    }

    public String borrarCantidad() {
        int seleccion = JOptionPane.showConfirmDialog(null, "¿Desea eliminar el producto?", "Confirmar borrado", JOptionPane.YES_NO_CANCEL_OPTION, JOptionPane.QUESTION_MESSAGE);
        //0 si
        //1 no
        //2 cancelar

        if (seleccion == 0) {
            Map<String, Object> session = ActionContext.getContext().getSession();

            Compra compraTemp = (Compra) session.get("carrito");

            List<ProductosCompra> listaProductosCompra = compraTemp.getProductosCompra();
            List<ProductosCompra> listaProductosCompraTemp = new ArrayList();

            Iterator iter = listaProductosCompra.iterator();

            while (iter.hasNext()) {
                ProductosCompra productosCompraTemp = (ProductosCompra) iter.next();

                if (productosCompraTemp.getProducto().getIdProducto() != idProducto) {
                    listaProductosCompraTemp.add(productosCompraTemp);
                }
            }
            compraTemp.setProductosCompra(listaProductosCompraTemp);
            session.put("carrito", compraTemp);
            msg = "El producto se ha eliminado correctamente de su carrito.";

            return "OK";
        } else {
            return "NOBORRAR";
        }


    }

    public String finalizarCompra() {
        Map<String, Object> session = ActionContext.getContext().getSession();
        Usuario usuario = (Usuario) session.get("usuario");
        Compra compra = (Compra) session.get("carrito");
        MetodoPago metodoPagoElegido = (MetodoPago) session.get("metodoPagoElegido");

        compra.setFechaCompra(new java.util.Date());

        if (metodoPagoElegido.getTipoPago().equals("Contrareembolso")) {
            compra.setEstadoCompra(estados.get(1));
        } else {
            compra.setEstadoCompra(estados.get(2));
        }

        compra.setPrecio(precioTotal);
        compra.setIdCliente(usuario.getIdUsuario());
        //compra.setMetodoPago(metodoPagoElegido.getIdMetodoPago());
        compra.getMetodoPago().setIdMetodoPago(metodoPagoElegido.getIdMetodoPago());
        //Recojo los productos antes de actualizar la compra
        List<ProductosCompra> listaProductosCompra = compra.getProductosCompra();

        compra = CompraDAO.obtenCompra(CompraDAO.insertarCompra(compra));
        CompraDAO.actualizaCompra(compra);

        for (int i = 0; i < listaProductosCompra.size(); i++) {

            listaProductosCompra.get(i).getId().setIdCompra((int) compra.getIdCompra());

            productosCompraDAO.insertarProductosCompra(listaProductosCompra.get(i));
        }
        compra.setProductosCompra(listaProductosCompra);
        compra.setMetodoPago(metodoPagoDAO.obtenMetodoPago(compra.getMetodoPago().getIdMetodoPago()));
        session.remove("carrito");
        session.remove("metodoPagoElegido");
        session.put("compra", compra);

        return "OK";
    }

    public String historial() {
        Map<String, Object> session = ActionContext.getContext().getSession();
        Usuario usuario = (Usuario) session.get("usuario");

        List<Compra> listaCompraUsuario = new ArrayList();
        List<Compra> listaCompraUsuarioTemp = new ArrayList();

        listaCompraUsuario = compraDAO.obtenListaCompras(usuario.getIdUsuario());

        for (int i = 0; i < listaCompraUsuario.size(); i++) {
            Compra compraUsuario = listaCompraUsuario.get(i);

            compraUsuario.setProductosCompra(productosCompraDAO.obtenListaProductosCompra(compraUsuario.getIdCompra()));

            listaCompraUsuarioTemp.add(compraUsuario);
            compraUsuario.setMetodoPago(metodoPagoDAO.obtenMetodoPago(compraUsuario.getMetodoPago().getIdMetodoPago()));
        }

        session.put("compraUsuarioActualizada", listaCompraUsuarioTemp);

        return "OK";
    }

    public String administrarCompras() {
        Map<String, Object> session = ActionContext.getContext().getSession();
        List<Compra> listaCompras = new ArrayList();

        listaCompras = compraDAO.listaCompras();

        //Necesitamos insertar el tipo de pago en cada compra para mostrarlo posteriormente
        for (int i = 0; i < listaCompras.size(); i++) {
            Compra compraTemp = listaCompras.get(i);
            compraTemp.setMetodoPago(metodoPagoDAO.obtenMetodoPago(compraTemp.getMetodoPago().getIdMetodoPago()));
        }
        session.put("listaCompras", listaCompras);

        return "OK";
    }

    public String modificarCompra() {

        Map<String, Object> session = ActionContext.getContext().getSession();
        List<Compra> listaCompras = (List<Compra>) session.get("listaCompras");

        for (int i = 0; i < listaCompras.size(); i++) {
            Compra compraTemp = listaCompras.get(i);
            if (compraTemp.getIdCompra() == this.idCompra) {
                compraTemp.setEstadoCompra(estado);
                compraDAO.actualizaCompra(compraTemp);
                estado = "";
            }
            administrarCompras();
        }
        return "OK";
    }

    public String detalleCompra() {
        Map<String, Object> session = ActionContext.getContext().getSession();
        Compra compra = compraDAO.obtenCompra(idCompra);
        ProductoDAO productoDAO = new ProductoDAO();
        compra.setProductosCompra(productosCompraDAO.obtenListaProductosCompra(idCompra));

        for (int i = 0; i < compra.getProductosCompra().size(); i++) {
            compra.getProductosCompra().get(i).setProducto(productoDAO.obtenProducto(compra.getProductosCompra().get(i).getId().getIdProducto()));;
        }

        compra.setMetodoPago(metodoPagoDAO.obtenMetodoPago(compra.getMetodoPago().getIdMetodoPago()));

        session.put("compra", compra);

        return "OK";
    }

    public String confirmarCompra() {
        return "OK";
    }

    public void setIdProducto(int idProducto) {
        this.idProducto = idProducto;
    }

    public int getIdProducto() {
        return this.idProducto;
    }

    public void setPrecioTotal(float precioTotal) {
        this.precioTotal = precioTotal;
    }

    public float getPrecioTotal() {
        return this.precioTotal;
    }

    public List<String> getEstados() {
        return estados;
    }

    public void setEstados(List<String> estados) {
        this.estados = estados;
    }

    public String getEstado() {
        return estado;
    }

    public void setEstado(String estado) {
        this.estado = estado;
    }

    public int getIdCompra() {
        return idCompra;
    }

    public void setIdCompra(int idCompra) {
        this.idCompra = idCompra;
    }

    public String getMsg() {
        return msg;
    }

    public void setMsg(String msg) {
        this.msg = msg;
    }
}
