/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package controlador;

import com.opensymphony.xwork2.ActionContext;
import com.opensymphony.xwork2.ActionSupport;
import dao.MetodoPagoDAO;
import dao.ProductoDAO;
import entidad.Compra;
import entidad.MetodoPago;
import entidad.Producto;
import entidad.ProductosCompra;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;

/**
 *
 * @author Jose Luis
 */
public class MetodoPagoControlador extends ActionSupport {

    private List<String> listaMetodosPago = new ArrayList();
    private String metodoPagoElegido = "";
    private String msg = "";
    private boolean modificado = false;

    public String elegirMetodoPago() {

        //Compruebo si se ha modificado el stock de algun producto del carrito mientras
        //la sesion del cliente estaba activa. Si el stock es inferior a la cantidad
        //de un producto concreto que tiene el cliente en el carrito, se le pondra a cero
        //y se le indicara al cliente que añada la cantidad que necesite, respetando el nuevo stock.

        Map<String, Object> session = ActionContext.getContext().getSession();
        Compra carrito = (Compra) session.get("carrito");
        List<ProductosCompra> productosCompra = carrito.getProductosCompra();
        ProductoDAO productoDAO = new ProductoDAO();

        for (int i = 0; i < productosCompra.size(); i++) {
            Producto productoStock = productoDAO.obtenProducto(productosCompra.get(i).getProducto().getIdProducto());

            if (productoStock.getStock() < productosCompra.get(i).getCantidad()) {
                productosCompra.get(i).setCantidad(0);
                modificado = true;
            }
        }

        if (modificado) {
            msg = "El stock de los productos de su carrito ha sido modificado mientras usted hacia su compra. Se ha modificado la cantidad de dichos productos a 0, por favor seleccione una nueva cantidad. Disculpe las molestias.";

            //actualizo el carrito
            carrito.setProductosCompra(productosCompra);

            return "KO";

        } else {
            List<MetodoPago> metodosPagoTemp = MetodoPagoDAO.obtenListaMetodoPago();

            session.put("metodosPago", metodosPagoTemp);

            for (int i = 0; i < metodosPagoTemp.size(); i++) {
                listaMetodosPago.add(metodosPagoTemp.get(i).getTipoPago() + " (" + metodosPagoTemp.get(i).getCoste() + " €)");
            }

            return "OK";
        }
    }

    public String continuarCompraPaso2() {
        Map<String, Object> session = ActionContext.getContext().getSession();
        Compra carrito = (Compra) session.get("carrito");
        List<MetodoPago> metodosPago = (List<MetodoPago>) session.get("metodosPago");

        for (int i = 0; i < metodosPago.size(); i++) {

            if (metodoPagoElegido.indexOf(metodosPago.get(i).getTipoPago()) != -1) {
                carrito.getMetodoPago().setIdMetodoPago(metodosPago.get(i).getIdMetodoPago());
                session.put("metodoPagoElegido", metodosPago.get(i));
            }
        }

        session.put("carrito", carrito);


        return "OK";
    }

    public List<String> getListaMetodosPago() {
        return this.listaMetodosPago;
    }

    public void setListaMetodosPago(List<String> listaMetodosPago) {
        this.listaMetodosPago = listaMetodosPago;
    }

    public String getMetodoPagoElegido() {
        return this.metodoPagoElegido;
    }

    public void setMetodoPagoElegido(String metodoPagoElegido) {
        this.metodoPagoElegido = metodoPagoElegido;
    }

    public String getMsg() {
        return msg;
    }

    public void setMsg(String msg) {
        this.msg = msg;
    }
}
