/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package controlador;

import com.opensymphony.xwork2.ActionContext;
import com.opensymphony.xwork2.ActionSupport;
import dao.CategoriaDAO;
import dao.ProductoDAO;
import dao.ValoracionDAO;
import entidad.Categoria;
import entidad.Producto;
import entidad.Usuario;
import entidad.Valoracion;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import javax.swing.JOptionPane;

/**
 *
 * @author Jose Luis
 */
public class ProductoControlador extends ActionSupport {

    ProductoDAO productoDAO = new ProductoDAO();
    Producto producto = new Producto();
    String msg = "";
    private String archivoFileName;
    private String imagen;
    private int idProducto;
    private String busqueda = "";
    private String cantidad = "";
    private String precioFormateado = "";
    private String stock = "";

    public String formularioRegistroProducto() {
        return "OK";
    }

    public List<Categoria> cargarCategoriasProductosBBDD() {

        List<Categoria> categorias = new ArrayList();
        List<Categoria> categoriasTemp = new ArrayList();

        categorias = CategoriaDAO.obtenListaCategorias();
        ProductoDAO productoDAO = new ProductoDAO();

        Iterator iter = categorias.iterator();
        while (iter.hasNext()) {
            Categoria categoria = new Categoria();
            categoria = (Categoria) iter.next();
            categoria.setProductos(productoDAO.obtenListaProductos(categoria.getIdCategoria()));
            categoriasTemp.add(categoria);
        }

        return (categoriasTemp);
    }

    public String nuevoProducto() {

        if (producto.getNombreProducto().isEmpty() || producto.getImagen().isEmpty() || precioFormateado.isEmpty() || stock.isEmpty() || producto.getDescripcion().isEmpty()) {
            msg = "Por favor, rellene todos los campos";
            return "KO";
        }

        if (this.precioFormateado.indexOf(".") > 0) {
            msg = "El formato del precio es incorrecto. Por favor, escriba 'x,xx'";
            return "KO";
        }

        this.precioFormateado = precioFormateado.replace(',', '.');

        //Comprobar si el precio formateado y el stock son numericos
        try {
            Float.parseFloat(precioFormateado);
        } catch (NumberFormatException nfe) {
            msg = "El precio debe ser numerico 'x,xx'";
            return "KO";
        }

        try {
            Integer.parseInt(stock);
        } catch (NumberFormatException nfe) {
            msg = "El stock debe ser numerico";
            return "KO";
        }

        Map<String, Object> session = ActionContext.getContext().getSession();
        Categoria categoria = (Categoria) session.get("categoriaTratada");

        producto.setPrecio(Float.parseFloat(this.precioFormateado));
        producto.setIdCategoria(categoria.getIdCategoria());
        producto.setValoracion((float) 5);
        producto.setStock(Integer.parseInt(this.stock));

        if (productoDAO.insertarProducto(producto)) {
            msg = "El Producto ha sido insertado correctamente.";

            producto.setIdProducto(productoDAO.obtenIdProducto(producto));
            categoria.addProducto(producto);
            session.put("categoriaTratada", categoria);

            session.put("listaCategoriasActualizada", this.cargarCategoriasProductosBBDD());

            return "OK";
        } else {
            msg = "Ha Ocurrido un Error al Insertar el Producto.";
            return "KO";
        }
    }

    public String administrarProducto() {
        Map<String, Object> session = ActionContext.getContext().getSession();
        Producto producto = productoDAO.obtenProducto(idProducto);

        this.precioFormateado = producto.getPrecio().toString();
        this.precioFormateado = this.precioFormateado.replace('.', ',');

        session.put("productoTratado", producto);

        return "OK";
    }

    public String eliminarProducto() {
        int seleccion = JOptionPane.showConfirmDialog(null, "¿Desea eliminar el producto del catalogo?", "Confirmar borrado", JOptionPane.YES_NO_CANCEL_OPTION, JOptionPane.QUESTION_MESSAGE);
        //0 si
        //1 no
        //2 cancelar

        if (seleccion == 0) {
            Map<String, Object> session = ActionContext.getContext().getSession();
            Producto productoTrat = (Producto) session.get("productoTratado");
            Categoria categoria = (Categoria) session.get("categoriaTratada");

            productoDAO.eliminaProducto(productoTrat);

            for (int i = 0; i < categoria.getProductos().size(); i++) {
                if (categoria.getProductos().get(i).getIdProducto() == productoTrat.getIdProducto()) {
                    categoria.getProductos().remove(i);
                }
            }

            session.put("categoriaTratada", categoria);

            session.put("listaCategoriasActualizada", this.cargarCategoriasProductosBBDD());
            msg = "El producto se ha eliminado correctamente del catalogo.";

            return "OK";
        } else {
            return "NOBORRAR";
        }
    }

    public String modificarProducto() {

        if (producto.getNombreProducto().isEmpty() || producto.getImagen().isEmpty() || precioFormateado.isEmpty() || stock.isEmpty() || producto.getDescripcion().isEmpty()) {
            msg = "Por favor, rellene todos los campos";
            return "KO";
        }

        if (this.precioFormateado.indexOf(".") > 0) {
            msg = "El formato del precio es incorrecto. Por favor, escriba 'x,xx'";
            return "KO";
        }

        this.precioFormateado = precioFormateado.replace(',', '.');

        //Comprobar si el precio formateado y el stock son numericos
        try {
            Float.parseFloat(precioFormateado);
        } catch (NumberFormatException nfe) {
            msg = "El precio debe ser numerico 'x,xx'";
            return "KO";
        }

        try {
            Integer.parseInt(stock);
        } catch (NumberFormatException nfe) {
            msg = "El stock debe ser numerico";
            return "KO";
        }

        Map<String, Object> session = ActionContext.getContext().getSession();
        Producto productoTrat = (Producto) session.get("productoTratado");
        Categoria categoria = (Categoria) session.get("categoriaTratada");


        productoTrat.setNombreProducto(producto.getNombreProducto());
        productoTrat.setImagen(producto.getImagen());
        productoTrat.setDescripcion(producto.getDescripcion());

        productoTrat.setPrecio(Float.parseFloat(this.precioFormateado));
        productoTrat.setStock(Integer.parseInt(stock));
        productoDAO.actualizaProducto(productoTrat);

        for (int i = 0; i < categoria.getProductos().size(); i++) {
            if (categoria.getProductos().get(i).getIdProducto() == productoTrat.getIdProducto()) {
                categoria.getProductos().set(i, productoTrat);
            }
        }

        session.put("listaCategoriasActualizada", this.cargarCategoriasProductosBBDD());
        return "OK";

    }

    public String producto() {
        Map<String, Object> session = ActionContext.getContext().getSession();

        Producto producto = productoDAO.obtenProducto(idProducto);
        boolean productoValorado = false;


        session.put("productoTratado", producto);

        //Si el cliente esta logueado, compruebo si ya ha valorado el producto
        if (session.get("usuario") != null) {
            ValoracionDAO valoracionDAO = new ValoracionDAO();
            List<Valoracion> listaValoracion = new ArrayList();
            Usuario usuario = (Usuario) session.get("usuario");

            productoValorado = valoracionDAO.valoradoPorCliente(usuario.getIdUsuario(), idProducto);
            if (productoValorado == true) {
                session.put("productoValorado", productoValorado);
            } else {
                session.remove("productoValorado");
            }
        }

        return "OK";
    }

    public String busqueda() {
        Map<String, Object> session = ActionContext.getContext().getSession();
        ProductoDAO productoDAO = new ProductoDAO();
        List<Producto> productosBuscados = new ArrayList();

        productosBuscados = productoDAO.busqueda(busqueda);

        session.put("productosBuscados", productosBuscados);

        return "OK";
    }

    public String cargaArchivoProducto() {

        try {

            imagen = archivoFileName;

        } catch (Exception e) {
            e.printStackTrace();
        }
        return "success";
    }

    public String administrarStock() {

        Map<String, Object> session = ActionContext.getContext().getSession();
        ProductoDAO productoDAO = new ProductoDAO();
        List<Producto> productosStock = new ArrayList();

        productosStock = productoDAO.stock();

        session.put("productosStock", productosStock);

        return "OK";
    }

    public String sumarCantidadStock() {

        //Comprobar si la cantidad es numerica
        try {
            Integer.parseInt(cantidad);
        } catch (NumberFormatException nfe) {
            msg = "La cantidad debe ser numerica";
            this.cantidad = "0";
            return "KO";
        }

        Map<String, Object> session = ActionContext.getContext().getSession();
        Producto productoTemp = productoDAO.obtenProducto(this.idProducto);

        productoTemp.setStock(productoTemp.getStock() + Integer.parseInt(this.cantidad));
        productoDAO.actualizaProducto(productoTemp);

        session.put("listaCategoriasActualizada", this.cargarCategoriasProductosBBDD());
        session.put("productosStock", productoDAO.stock());

        this.cantidad = "0";

        return "OK";
    }

    public String restarCantidadStock() {

        //Comprobar si la cantidad es numerica
        try {
            Integer.parseInt(cantidad);
        } catch (NumberFormatException nfe) {
            msg = "La cantidad debe ser numerica";
            this.cantidad = "0";
            return "KO";
        }
        Producto productoTratado = ProductoDAO.obtenProducto(this.idProducto);
        if (Integer.parseInt(this.cantidad) > productoTratado.getStock()) {
            msg = "No se puede restar mas cantidad que el stock disponible. Minimo 0";
            this.cantidad = "0";

            return "KO";
        }
        Map<String, Object> session = ActionContext.getContext().getSession();
        Producto productoTemp = productoDAO.obtenProducto(this.idProducto);

        productoTemp.setStock(productoTemp.getStock() - Integer.parseInt(this.cantidad));
        productoDAO.actualizaProducto(productoTemp);

        session.put("listaCategoriasActualizada", this.cargarCategoriasProductosBBDD());
        session.put("productosStock", productoDAO.stock());

        this.cantidad = "0";

        return "OK";
    }

    public String cargaArchivoModificadoProducto() {
        imagen = archivoFileName;
        return "success";
    }

    public Producto getProducto() {
        return producto;
    }

    public void setProducto(Producto producto) {
        this.producto = producto;
    }

    public int getIdProducto() {
        return idProducto;
    }

    public void setIdProducto(int idProducto) {
        this.idProducto = idProducto;
    }

    public String getMsg() {
        return msg;
    }

    public void setArchivoFileName(String archivoFileName) {
        this.archivoFileName = archivoFileName;
    }

    public String getArchivoFileName() {
        return archivoFileName;
    }

    public String getImagen() {
        return imagen;
    }

    public void setImagen(String imagen) {
        this.imagen = imagen;
    }

    public String getBusqueda() {
        return this.busqueda;
    }

    public void setBusqueda(String busqueda) {
        this.busqueda = busqueda;
    }

    public String getCantidad() {
        return this.cantidad;
    }

    public void setCantidad(String cantidad) {
        this.cantidad = cantidad;
    }

    public String getPrecioFormateado() {
        return this.precioFormateado;
    }

    public void setPrecioFormateado(String precioFormateado) {
        this.precioFormateado = precioFormateado;
    }

    public String getStock() {
        return this.stock;
    }

    public void setStock(String stock) {
        this.stock = stock;
    }
}
