/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package controlador;

import com.opensymphony.xwork2.ActionContext;
import com.opensymphony.xwork2.ActionSupport;
import dao.UsuarioDAO;
import entidad.Usuario;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Properties;
import javax.mail.Message;
import javax.mail.Session;
import javax.mail.Transport;
import javax.mail.internet.InternetAddress;
import javax.mail.internet.MimeMessage;
import javax.swing.JOptionPane;

/**
 *
 * @author Jose Luis
 */
public class UsuarioControlador extends ActionSupport {

    private Usuario usuario = new Usuario();
    private UsuarioDAO usuarioDAO = new UsuarioDAO();
    private String msg = "";
    private int idUsuario;
    private String email = "";
    private String repetirPassword = "";
    private String codigoPostal = "";
    private String telefono = "";

    //Metodos de usuario
    public String insertarUsuario() {
        Map<String, Object> session = ActionContext.getContext().getSession();
        Usuario usuarioTemp = null;

        //Comprobar si algun campo viene vacio
        if (usuario.getLogin().isEmpty() || usuario.getPassword().isEmpty() || this.repetirPassword.isEmpty() || usuario.getEmail().isEmpty() || usuario.getNombre().isEmpty() || usuario.getApellidos().isEmpty() || usuario.getDni().isEmpty() || usuario.getDireccion().isEmpty() || usuario.getLocalidad().isEmpty() || usuario.getCiudad().isEmpty() || this.codigoPostal.isEmpty() || usuario.getPais().isEmpty()) {
            msg = "Por favor, rellene todos los campos obligatorios (*).";
            return "KO";
        }

        //Comprobar si el codigo postal o el telefono son numericos
        try {
            Integer.parseInt(codigoPostal);
        } catch (NumberFormatException nfe) {
            msg = "El codigo postal debe ser numerico";
            return "KO";
        }
        try {
            if (!telefono.isEmpty()) {
                Integer.parseInt(telefono);
            }
        } catch (NumberFormatException nfe) {
            msg = "El telefono debe ser numerico";
            return "KO";
        }

        //Comprobar si las contraseñas son iguales
        if (!usuario.getPassword().equals(this.repetirPassword)) {
            msg = "Las contraseñas no coinciden, por favor, intentelo de nuevo.";
            return "KO";
        }

        //Comprobar si el login ya existe en la base de datos
        usuarioTemp = usuarioDAO.getUsuarioLogin(usuario.getLogin());
        if (usuarioTemp != null) {
            msg = "El usuario ya existe.";
            return "KO";
        }

        //Comprobar si el email ya existe en la base de datos
        usuarioTemp = usuarioDAO.getUsuario(usuario.getEmail());
        if (usuarioTemp != null) {
            msg = "El email ya existe.";
            return "KO";
        } //Si todo esta correcto insertamos el usuario
        else {
            usuario.setRol(usuario.ROLUSUARIO[0]);
            usuario.setCodigoPostal(Integer.parseInt(this.codigoPostal));
            if (telefono.isEmpty()) {
                usuario.setTelefono(0);
            } else {
                usuario.setTelefono(Integer.parseInt(this.telefono));
            }

            if (usuarioDAO.insertarUsuario(usuario)) {
                session.put("usuario", usuario);
                return "OK";
            } else {
                msg = "Ha Ocurrido un Error al Insertar el Usuario. Por favor, intentelo de nuevo.";
                return "KO";
            }
        }

    }

    public String insertarAdministrador() {
        Map<String, Object> session = ActionContext.getContext().getSession();
        Usuario usuarioTemp = null;

        //Comprobar si algun campo viene vacio
        if (usuario.getLogin().isEmpty() || usuario.getPassword().isEmpty() || this.repetirPassword.isEmpty() || usuario.getEmail().isEmpty() || usuario.getNombre().isEmpty() || usuario.getApellidos().isEmpty() || usuario.getDni().isEmpty() || usuario.getDireccion().isEmpty() || usuario.getLocalidad().isEmpty() || usuario.getCiudad().isEmpty() || this.codigoPostal.isEmpty() || usuario.getPais().isEmpty()) {
            msg = "Por favor, rellene todos los campos obligatorios (*).";
            return "KO";
        }

        //Comprobar si el codigo postal o el telefono son numericos
        try {
            Integer.parseInt(codigoPostal);
        } catch (NumberFormatException nfe) {
            msg = "El codigo postal debe ser numerico";
            return "KO";
        }
        try {
            if (!telefono.isEmpty()) {
                Integer.parseInt(telefono);
            }
        } catch (NumberFormatException nfe) {
            msg = "El telefono debe ser numerico";
            return "KO";
        }

        //Comprobar si las contraseñas son iguales
        if (!usuario.getPassword().equals(this.repetirPassword)) {
            msg = "Las contraseñas no coinciden, por favor, intentelo de nuevo.";
            return "KO";
        }

        //Comprobar si el login ya existe en la base de datos
        usuarioTemp = usuarioDAO.getUsuarioLogin(usuario.getLogin());
        if (usuarioTemp != null) {
            msg = "El usuario ya existe.";
            return "KO";
        }

        //Comprobar si el email ya existe en la base de datos
        usuarioTemp = usuarioDAO.getUsuario(usuario.getEmail());
        if (usuarioTemp != null) {
            msg = "El email ya existe.";
            return "KO";
        } //Si todo esta correcto insertamos el administrador
        else {
            usuario.setRol(usuario.ROLUSUARIO[1]);
            usuario.setCodigoPostal(Integer.parseInt(this.codigoPostal));
            if (telefono.isEmpty()) {
                usuario.setTelefono(0);
            } else {
                usuario.setTelefono(Integer.parseInt(this.telefono));
            }

            if (usuarioDAO.insertarUsuario(usuario)) {
                msg = "El Administrador ha sido Insertado Correctamente.";
                this.administrarUsuarios();
                return "OK";
            } else {
                msg = "Ha Ocurrido un Error al Insertar el Administrador.";
                return "KO";
            }
        }

    }

    public String administrarUsuarios() {

        Map<String, Object> session = ActionContext.getContext().getSession();
        UsuarioDAO usuarioDAO = new UsuarioDAO();
        List<Usuario> administradores = new ArrayList();

        administradores = usuarioDAO.selectAdministradores();

        session.put("listaAdministradores", administradores);

        return "OK";
    }

    public String validarUsuario() {
        Map<String, Object> session = ActionContext.getContext().getSession();
        Usuario temp = null;

        temp = usuarioDAO.selectUsuario(usuario.getLogin(), usuario.getPassword());

        if (temp == null) {
            msg = "El usuario o la contraseña son incorrectos";
            //session.put("mensaje",msg);
        } else {
            if (temp.getRol().equals("cliente")) {
                session.put("usuario", temp);
                if (session.get("paginaActual") == "index") {
                    return "index";
                }
                if (session.get("paginaActual") == "productosCategoria") {
                    return "productosCategoria";
                }
                if (session.get("paginaActual") == "producto") {
                    return "producto";
                }
                if (session.get("paginaActual") == "carrito") {
                    return "carrito";
                }
                if (session.get("paginaActual") == "busqueda") {
                    return "busqueda";
                }
            } else {
                session.put("administrador", temp);
                return "administrador";
            }
        }
        return "KO";
    }

    public String administrarAdministrador() {

        Map<String, Object> session = ActionContext.getContext().getSession();

        List<Usuario> listaAdministradores = (List<Usuario>) session.get("listaAdministradores");
        Iterator iter = listaAdministradores.iterator();

        while (iter.hasNext()) {
            Usuario administradorTemp = new Usuario();
            administradorTemp = (Usuario) iter.next();

            if (administradorTemp.getIdUsuario() == idUsuario) {
                session.put("administradorTratado", administradorTemp);
            }
        }

        return "OK";
    }

    public String modificarAdministrador() {

        Map<String, Object> session = ActionContext.getContext().getSession();
        Usuario administradorTratado = (Usuario) session.get("administradorTratado");
        List<Usuario> administradores = new ArrayList();
        Usuario usuarioTemp = null;

        //Comprobar si algun campo viene vacio
        if (usuario.getLogin().isEmpty() || usuario.getPassword().isEmpty() || this.repetirPassword.isEmpty() || usuario.getEmail().isEmpty() || usuario.getNombre().isEmpty() || usuario.getApellidos().isEmpty() || usuario.getDni().isEmpty() || usuario.getDireccion().isEmpty() || usuario.getLocalidad().isEmpty() || usuario.getCiudad().isEmpty() || this.codigoPostal.isEmpty() || usuario.getPais().isEmpty()) {
            msg = "Por favor, rellene todos los campos obligatorios (*).";
            return "KO";
        }

        //Comprobar si el codigo postal o el telefono son numericos
        try {
            Integer.parseInt(codigoPostal);
        } catch (NumberFormatException nfe) {
            msg = "El codigo postal debe ser numerico";
            return "KO";
        }
        try {
            if (!telefono.isEmpty()) {
                Integer.parseInt(telefono);
            }
        } catch (NumberFormatException nfe) {
            msg = "El telefono debe ser numerico";
            return "KO";
        }

        //Comprobar si las contraseñas son iguales
        if (!usuario.getPassword().equals(this.repetirPassword)) {
            msg = "Las contraseñas no coinciden, por favor, intentelo de nuevo.";
            return "KO";
        }

        //Comprobar si el login ya existe en la base de datos, si ha sido cambiado previamente
        if (!administradorTratado.getLogin().equals(usuario.getLogin())) {
            usuarioTemp = usuarioDAO.getUsuarioLogin(usuario.getLogin());
            if (usuarioTemp != null) {
                msg = "El usuario ya existe.";
                return "KO";
            }
        }

        //Comprobar si el email ya existe en la base de datos, si ha sido cambiado previamente
        if (!administradorTratado.getEmail().equals(usuario.getEmail())) {
            usuarioTemp = usuarioDAO.getUsuario(usuario.getEmail());
            if (usuarioTemp != null) {
                msg = "El email ya existe.";
                return "KO";
            }
        }
        //Si todo esta correcto insertamos el administrador

        usuario.setCodigoPostal(Integer.parseInt(this.codigoPostal));
        if (telefono.isEmpty()) {
            usuario.setTelefono(0);
        } else {
            usuario.setTelefono(Integer.parseInt(this.telefono));
        }

        administradorTratado.setLogin(usuario.getLogin());
        administradorTratado.setPassword(usuario.getPassword());
        administradorTratado.setEmail(usuario.getEmail());
        administradorTratado.setNombre(usuario.getNombre());
        administradorTratado.setApellidos(usuario.getApellidos());
        administradorTratado.setDni(usuario.getDni());
        administradorTratado.setDireccion(usuario.getDireccion());
        administradorTratado.setLocalidad(usuario.getLocalidad());
        administradorTratado.setCiudad(usuario.getCiudad());
        administradorTratado.setCodigoPostal(usuario.getCodigoPostal());
        administradorTratado.setPais(usuario.getPais());
        administradorTratado.setTelefono(usuario.getTelefono());

        usuarioDAO.actualizaAdministrador(administradorTratado);

        administradores = usuarioDAO.selectAdministradores();

        session.put("listaAdministradores", administradores);

        msg = "Los datos han sido modificados correctamente.";

        return "OK";
    }

    public String eliminarAdministrador() {
        int seleccion = JOptionPane.showConfirmDialog(null, "¿Desea eliminar el administrador del sistema?", "Confirmar borrado", JOptionPane.YES_NO_CANCEL_OPTION, JOptionPane.QUESTION_MESSAGE);
        //0 si
        //1 no
        //2 cancelar

        if (seleccion == 0) {
            Map<String, Object> session = ActionContext.getContext().getSession();
            Usuario administradorTratado = (Usuario) session.get("administradorTratado");
            List<Usuario> administradores = new ArrayList();

            usuarioDAO.eliminaAdministrador(administradorTratado);

            administradores = usuarioDAO.selectAdministradores();

            session.put("listaAdministradores", administradores);

            msg = "El administrador se ha eliminado correctamente del sistema.";

            return "OK";
        } else {
            return "NOBORRAR";
        }
    }

    public String modificarCliente() {

        Map<String, Object> session = ActionContext.getContext().getSession();
        Usuario clienteTratado = (Usuario) session.get("usuario");
        Usuario usuarioTemp = null;

        //Comprobar si algun campo viene vacio
        if (usuario.getLogin().isEmpty() || usuario.getPassword().isEmpty() || this.repetirPassword.isEmpty() || usuario.getEmail().isEmpty() || usuario.getNombre().isEmpty() || usuario.getApellidos().isEmpty() || usuario.getDni().isEmpty() || usuario.getDireccion().isEmpty() || usuario.getLocalidad().isEmpty() || usuario.getCiudad().isEmpty() || this.codigoPostal.isEmpty() || usuario.getPais().isEmpty()) {
            msg = "Por favor, rellene todos los campos oligatorios (*).";
            return "KO";
        }

        //Comprobar si el codigo postal o el telefono son numericos
        try {
            Integer.parseInt(codigoPostal);
        } catch (NumberFormatException nfe) {
            msg = "El codigo postal debe ser numerico";
            return "KO";
        }
        try {
            if (!telefono.isEmpty()) {
                Integer.parseInt(telefono);
            }
        } catch (NumberFormatException nfe) {
            msg = "El telefono debe ser numerico";
            return "KO";
        }

        //Comprobar si las contraseñas son iguales
        if (!usuario.getPassword().equals(this.repetirPassword)) {
            msg = "Las contraseñas no coinciden, por favor, intentelo de nuevo.";
            return "KO";
        }

        //Comprobar si el login ya existe en la base de datos, si ha sido cambiado previamente
        if (!clienteTratado.getLogin().equals(usuario.getLogin())) {
            usuarioTemp = usuarioDAO.getUsuarioLogin(usuario.getLogin());
            if (usuarioTemp != null) {
                msg = "El usuario ya existe.";
                return "KO";
            }
        }

        //Comprobar si el email ya existe en la base de datos, si ha sido cambiado previamente
        if (!clienteTratado.getEmail().equals(usuario.getEmail())) {
            usuarioTemp = usuarioDAO.getUsuario(usuario.getEmail());
            if (usuarioTemp != null) {
                msg = "El email ya existe.";
                return "KO";
            }
        }
        //Si todo esta correcto insertamos el cliente

        usuario.setCodigoPostal(Integer.parseInt(this.codigoPostal));

        if (telefono.isEmpty()) {
            usuario.setTelefono(0);
        } else {
            usuario.setTelefono(Integer.parseInt(this.telefono));
        }

        clienteTratado.setLogin(usuario.getLogin());
        clienteTratado.setPassword(usuario.getPassword());
        clienteTratado.setEmail(usuario.getEmail());
        clienteTratado.setNombre(usuario.getNombre());
        clienteTratado.setApellidos(usuario.getApellidos());
        clienteTratado.setDni(usuario.getDni());
        clienteTratado.setDireccion(usuario.getDireccion());
        clienteTratado.setLocalidad(usuario.getLocalidad());
        clienteTratado.setCiudad(usuario.getCiudad());
        clienteTratado.setCodigoPostal(usuario.getCodigoPostal());
        clienteTratado.setPais(usuario.getPais());
        clienteTratado.setTelefono(usuario.getTelefono());

        usuarioDAO.actualizaAdministrador(clienteTratado);


        session.put("usuario", clienteTratado);

        msg = "Los datos han sido modificados correctamente.";

        return "OK";
    }

    public String eliminarCliente() {
        int seleccion = JOptionPane.showConfirmDialog(null, "¿Desea eliminar su cuenta del sistema?", "Confirmar borrado", JOptionPane.YES_NO_CANCEL_OPTION, JOptionPane.QUESTION_MESSAGE);
        //0 si
        //1 no
        //2 cancelar

        if (seleccion == 0) {
            Map<String, Object> session = ActionContext.getContext().getSession();
            Usuario clienteTratado = (Usuario) session.get("usuario");

            usuarioDAO.eliminaAdministrador(clienteTratado);

            session.remove("usuario");
            msg = "Su cuenta ha sido eliminada correctamente.";

            return "OK";
        } else {
            return "NOBORRAR";
        }
    }

    public String enviarCorreoPassword() throws Exception {

        try {

            Usuario usuario = UsuarioDAO.getUsuario(email);

            if (usuario == null) {
                msg = "El correo no pertenece a ningun cliente registrado en el sistema.";

                return "KO";
            }

            Properties props = new Properties();
            props.setProperty("mail.smtp.host", "smtp.gmail.com");
            props.setProperty("mail.smtp.starttls.enable", "true");
            props.setProperty("mail.smtp.port", "587");
            props.setProperty("mail.smtp.user", "webcine.jdelho@gmail.com");
            props.setProperty("mail.smtp.auth", "true");

            // Preparamos la sesion
            Session session = Session.getDefaultInstance(props);

            // Construimos el mensaje
            MimeMessage message = new MimeMessage(session);
            message.setFrom(new InternetAddress("webcine.jdelho@gmail.com"));
            message.addRecipient(
                    Message.RecipientType.TO,
                    new InternetAddress(email));
            message.setSubject("Informacion WebCine");
            message.setText("Estimado " + usuario.getNombre() + " " + usuario.getApellidos() + ":\n\n" + "La informacion de su cuenta es la siguiente: " + "\n\n" + "Usuario: " + usuario.getLogin() + "\n" + "Password: " + usuario.getPassword());

            // Lo enviamos.
            Transport t = session.getTransport("smtp");
            t.connect("webcine.jdelho@gmail.com", "webcine12345");
            t.sendMessage(message, message.getAllRecipients());

            // Cierre.
            t.close();

        } catch (Exception e) {
            e.printStackTrace();
        }

        msg = "El correo ha sido enviado correctamente, por favor, compruebe su bandeja de entrada";

        return "OK";
    }

    //Vistas
    public String recordarPassword() {
        return "OK";
    }

    public String administrarCliente() {
        return "OK";
    }

    public String formularioRegistroUsuario() {
        return "OK";
    }

    public String formularioRegistroAdministrador() {

        return "OK";
    }

    public String desconectarse() {
        Map<String, Object> session = ActionContext.getContext().getSession();
        session.remove("usuario");

        return "OK";
    }

    public String paginaPrincipal() {
        return "OK";
    }

    public String getMsg() {
        return msg;
    }

    public void setMsg(String msg) {
        this.msg = msg;
    }

    public Usuario getUsuario() {
        return usuario;
    }

    public void setUsuario(Usuario usuario) {
        this.usuario = usuario;
    }

    public void setIdUsuario(int idUsuario) {
        this.idUsuario = idUsuario;
    }

    public int getIdUsuario() {
        return this.idUsuario;
    }

    public void setEmail(String email) {
        this.email = email;
    }

    public String getEmail() {
        return this.email;
    }

    public void setRepetirPassword(String repetirPassword) {
        this.repetirPassword = repetirPassword;
    }

    public String getRepetirPassword() {
        return this.repetirPassword;
    }

    public void setCodigoPostal(String codigoPostal) {
        this.codigoPostal = codigoPostal;
    }

    public String getCodigoPostal() {
        return this.codigoPostal;
    }

    public void setTelefono(String telefono) {
        this.telefono = telefono;
    }

    public String getTelefono() {
        return this.telefono;
    }
}
