/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package controlador;

import com.opensymphony.xwork2.ActionContext;
import com.opensymphony.xwork2.ActionSupport;
import dao.CategoriaDAO;
import dao.ProductoDAO;
import dao.ValoracionDAO;
import entidad.Categoria;
import entidad.Producto;
import entidad.Usuario;
import entidad.Valoracion;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

/**
 *
 * @author Jose Luis
 */
public class ValoracionControlador extends ActionSupport {

    private ValoracionDAO valoracionDAO = new ValoracionDAO();
    private int valoracion;

    public List<Categoria> cargarCategoriasProductosBBDD() {

        List<Categoria> categorias = new ArrayList();
        List<Categoria> categoriasTemp = new ArrayList();

        categorias = CategoriaDAO.obtenListaCategorias();
        ProductoDAO productoDAO = new ProductoDAO();

        Iterator iter = categorias.iterator();
        while (iter.hasNext()) {
            Categoria categoria = new Categoria();
            categoria = (Categoria) iter.next();
            categoria.setProductos(productoDAO.obtenListaProductos(categoria.getIdCategoria()));
            categoriasTemp.add(categoria);
        }

        return (categoriasTemp);
    }
    
    public String valorar() {

        Map<String, Object> session = ActionContext.getContext().getSession();
        List<Valoracion> valoracionesProducto = new ArrayList();
        ProductoDAO productoDAO = new ProductoDAO();
        Usuario cliente = new Usuario();
        Producto producto = new Producto();
        float sumaValoracion = 0;
        float mediaValoracion = 0;

        cliente = (Usuario) session.get("usuario");
        producto = (Producto) session.get("productoTratado");

        Valoracion valoracionTemp = new Valoracion(producto.getIdProducto(), cliente.getIdUsuario(), (float) this.valoracion);

        valoracionDAO.valorar(valoracionTemp);

        //Ahora recojemos todas las varolariones de un producto para generar su nueva media
        valoracionesProducto = valoracionDAO.valoracionesProducto(producto.getIdProducto());

        for (int i = 0; i < valoracionesProducto.size(); i++) {
            valoracionTemp = valoracionesProducto.get(i);
            sumaValoracion = sumaValoracion + valoracionTemp.getValoracion();
        }
        //Le sumo 5 por que la valoracion del producto por defecto al crearlo es 5
        sumaValoracion = sumaValoracion + 5;
        //valoracionesProducto.size()+1 por la suma del 5 anterior
        mediaValoracion = sumaValoracion / (valoracionesProducto.size()+1);

        producto.setValoracion(mediaValoracion);
        productoDAO.actualizaProducto(producto);

        session.put("listaCategoriasActualizada", this.cargarCategoriasProductosBBDD());
        session.put("productoValorado", true);

        return "OK";
    }

    public void setValoracion(int valoracion) {
        this.valoracion = valoracion;
    }

    public int getValoracion() {
        return this.valoracion;
    }
}
