/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package dao;

import entidad.Categoria;
import java.util.List;
import org.hibernate.HibernateException;
import org.hibernate.Session;
import org.hibernate.Transaction;

/**
 *
 * @author Jose Luis
 */
public class CategoriaDAO {

    private Session session;
    private Transaction transaction;

    public CategoriaDAO() {
    }

    protected void iniciaOperacion() throws HibernateException {
        session = HibernateUtil.getSessionFactory().openSession();
        transaction = session.beginTransaction();
    }

    protected Session getSession() {
        return session;
    }

    protected Transaction getTransaction() {
        return transaction;
    }

    protected void manejaExcepcion(HibernateException he) throws HibernateException {
        CategoriaDAO catDAO = new CategoriaDAO() {
        };
        catDAO.getTransaction().rollback();
        throw new HibernateException("Ocurrió un error en la base de datos", he);
    }

    public boolean insertarCategoria(Categoria cat) {

        CategoriaDAO catDAO = new CategoriaDAO() {
        };

        try {

            catDAO.iniciaOperacion();
            catDAO.getSession().save(cat);
            catDAO.getTransaction().commit();

        } catch (HibernateException he) {
            catDAO.manejaExcepcion(he);
            throw he;
        } finally {
            catDAO.getSession().close();
        }
        return true;
    }

    public static List<Categoria> obtenListaCategorias() throws HibernateException {

        List<Categoria> listaCategorias = null;
        CategoriaDAO catDAO = new CategoriaDAO() {
        };

        try {
            catDAO.iniciaOperacion();
            listaCategorias = catDAO.getSession().createQuery("from Categoria ORDER BY nombreCategoria").list();
        } catch (HibernateException he) {
            catDAO.manejaExcepcion(he);
            throw he;
        } finally {
            catDAO.getSession().close();
        }

        return listaCategorias;
    }

    public static Categoria obtenCategoria(int idCategoria) throws HibernateException {
        Categoria categoria = null;
        CategoriaDAO catDAO = new CategoriaDAO() {
        };
        try {
            catDAO.iniciaOperacion();
            categoria = (Categoria) catDAO.getSession().get(Categoria.class, idCategoria);
        } catch (HibernateException he) {
            catDAO.manejaExcepcion(he);
            throw he;
        } finally {
            catDAO.getSession().close();
        }
        return categoria;
    }

    public static void actualizaCategoria(Categoria categoria) throws HibernateException {
        CategoriaDAO catDAO = new CategoriaDAO() {
        };

        try {
            catDAO.iniciaOperacion();
            catDAO.getSession().update(categoria);
            catDAO.getTransaction().commit();
        } catch (HibernateException he) {
            catDAO.manejaExcepcion(he);
            throw he;
        } finally {
            catDAO.getSession().close();
        }
    }

    public static void eliminaCategoria(Categoria categoria) throws HibernateException {
        CategoriaDAO catDAO = new CategoriaDAO() {
        };
        try {
            catDAO.iniciaOperacion();
            catDAO.getSession().delete(categoria);
            catDAO.getTransaction().commit();
        } catch (HibernateException he) {
            catDAO.manejaExcepcion(he);
            throw he;
        } finally {
            catDAO.getSession().close();
        }
    }
}
