/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package dao;

import entidad.Compra;
import java.util.List;
import org.hibernate.HibernateException;
import org.hibernate.Query;
import org.hibernate.Session;
import org.hibernate.Transaction;

/**
 *
 * @author Jose Luis
 */
public class CompraDAO {

    private Session session;
    private Transaction transaction;

    public CompraDAO() {
    }

    protected void iniciaOperacion() throws HibernateException {
        session = HibernateUtil.getSessionFactory().openSession();
        transaction = session.beginTransaction();
    }

    protected Session getSession() {
        return session;
    }

    protected Transaction getTransaction() {
        return transaction;
    }

    protected void manejaExcepcion(HibernateException he) throws HibernateException {
        CompraDAO compraDAO = new CompraDAO() {
        };
        compraDAO.getTransaction().rollback();
        throw new HibernateException("Ocurrió un error en la base de datos", he);
    }

    public static int insertarCompra(Compra compra) {
        CompraDAO compraDAO = new CompraDAO() {
        };
        int id;

        try {
            compraDAO.iniciaOperacion();
            id = (Integer) compraDAO.getSession().save(compra);
            compraDAO.getTransaction().commit();
        } catch (HibernateException he) {
            compraDAO.manejaExcepcion(he);
            throw he;
        } finally {
            compraDAO.getSession().close();
        }
        return id;

    }

    public static Compra obtenCompra(int idCompra) throws HibernateException {
        Compra compra = null;
        CompraDAO compraDAO = new CompraDAO() {
        };
        try {
            compraDAO.iniciaOperacion();
            compra = (Compra) compraDAO.getSession().get(Compra.class, idCompra);
        } catch (HibernateException he) {
            compraDAO.manejaExcepcion(he);
            throw he;
        } finally {
            compraDAO.getSession().close();
        }
        return compra;
    }

    public static void actualizaCompra(Compra compra) throws HibernateException {
        CompraDAO compraDAO = new CompraDAO() {
        };
        try {
            compraDAO.iniciaOperacion();
            compraDAO.getSession().update(compra);
            compraDAO.getTransaction().commit();
        } catch (HibernateException he) {
            compraDAO.manejaExcepcion(he);
            throw he;
        } finally {
            compraDAO.getSession().close();
        }
    }

    public static List<Compra> obtenListaCompras(int idUsuario) throws HibernateException {

        List<Compra> listaCompras = null;
        CompraDAO compraDAO = new CompraDAO() {
        };

        try {

            compraDAO.iniciaOperacion();
            Query query = compraDAO.getSession().createQuery("from Compra where idCliente = :idCliente ORDER BY fechaCompra DESC");
            query.setParameter("idCliente", idUsuario);

            listaCompras = query.list();

        } catch (HibernateException he) {
            compraDAO.manejaExcepcion(he);
            throw he;
        } finally {
            compraDAO.getSession().close();
        }

        return listaCompras;
    }

    public static List<Compra> listaCompras() throws HibernateException {

        List<Compra> listaCompras = null;
        CompraDAO compraDAO = new CompraDAO() {
        };

        try {

            compraDAO.iniciaOperacion();
            Query query = compraDAO.getSession().createQuery("from Compra ORDER BY fechaCompra DESC");

            listaCompras = query.list();

        } catch (HibernateException he) {
            compraDAO.manejaExcepcion(he);
            throw he;
        } finally {
            compraDAO.getSession().close();
        }

        return listaCompras;
    }
}
