/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package dao;

import entidad.MetodoPago;
import java.util.List;
import org.hibernate.HibernateException;
import org.hibernate.Query;
import org.hibernate.Session;
import org.hibernate.Transaction;

/**
 *
 * @author Jose Luis
 */
public class MetodoPagoDAO {

    private Session session;
    private Transaction transaction;

    public MetodoPagoDAO() {
    }

    protected void iniciaOperacion() throws HibernateException {
        session = HibernateUtil.getSessionFactory().openSession();
        transaction = session.beginTransaction();
    }

    protected Session getSession() {
        return session;
    }

    protected Transaction getTransaction() {
        return transaction;
    }

    protected void manejaExcepcion(HibernateException he) throws HibernateException {
        MetodoPagoDAO mpagoDAO = new MetodoPagoDAO() {
        };
        mpagoDAO.getTransaction().rollback();
        throw new HibernateException("Ocurrió un error en la base de datos", he);
    }

    public static List<MetodoPago> obtenListaMetodoPago() throws HibernateException {

        List<MetodoPago> listaMetodoPago = null;
        MetodoPagoDAO mpagoDAO = new MetodoPagoDAO() {
        };

        try {

            mpagoDAO.iniciaOperacion();
            listaMetodoPago = mpagoDAO.getSession().createQuery("from MetodoPago").list();

        } catch (HibernateException he) {
            mpagoDAO.manejaExcepcion(he);
            throw he;
        } finally {
            mpagoDAO.getSession().close();
        }

        return listaMetodoPago;
    }

    public static MetodoPago obtenMetodoPago(int idMetodoPago) throws HibernateException {

        MetodoPago metodoPago = null;
        MetodoPagoDAO mpagoDAO = new MetodoPagoDAO() {
        };

        try {

            mpagoDAO.iniciaOperacion();
            Query query = mpagoDAO.getSession().createQuery("from MetodoPago where idMetodoPago = :idMetodoPago");
            query.setParameter("idMetodoPago", idMetodoPago);

            metodoPago = (MetodoPago) query.uniqueResult();

        } catch (HibernateException he) {
            mpagoDAO.manejaExcepcion(he);
            throw he;
        } finally {
            mpagoDAO.getSession().close();
        }

        return metodoPago;
    }
}
