/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package dao;

import entidad.ProductosCompra;
import java.util.List;
import org.hibernate.HibernateException;
import org.hibernate.Query;
import org.hibernate.Session;
import org.hibernate.Transaction;

/**
 *
 * @author Jose Luis
 */
public class ProductosCompraDAO {

    private Session session;
    private Transaction transaction;

    public ProductosCompraDAO() {
    }

    protected void iniciaOperacion() throws HibernateException {
        session = HibernateUtil.getSessionFactory().openSession();
        transaction = session.beginTransaction();
    }

    protected Session getSession() {
        return session;
    }

    protected Transaction getTransaction() {
        return transaction;
    }

    protected void manejaExcepcion(HibernateException he) throws HibernateException {
        ProductosCompraDAO pCompraDAO = new ProductosCompraDAO() {
        };
        pCompraDAO.getTransaction().rollback();
        throw new HibernateException("Ocurrió un error en la base de datos", he);
    }

    public static void insertarProductosCompra(ProductosCompra productosCompra) {
        ProductosCompraDAO pCompraDAO = new ProductosCompraDAO() {
        };

        try {
            pCompraDAO.iniciaOperacion();
            pCompraDAO.getSession().save(productosCompra);
            pCompraDAO.getTransaction().commit();
        } catch (HibernateException he) {
            pCompraDAO.manejaExcepcion(he);
            throw he;
        } finally {
            pCompraDAO.getSession().close();
        }

    }

    public static List<ProductosCompra> obtenListaProductosCompra(int idCompra) throws HibernateException {

        List<ProductosCompra> listaProductosCompra = null;
        ProductosCompraDAO pCompraDAO = new ProductosCompraDAO() {
        };

        try {

            pCompraDAO.iniciaOperacion();
            Query query = pCompraDAO.getSession().createQuery("from ProductosCompra where idCompra = :idCompra");
            query.setParameter("idCompra", idCompra);

            listaProductosCompra = query.list();

        } catch (HibernateException he) {
            pCompraDAO.manejaExcepcion(he);
            throw he;
        } finally {
            pCompraDAO.getSession().close();
        }

        return listaProductosCompra;
    }
}
