/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package dao;

import entidad.Usuario;
import java.util.List;
import org.hibernate.HibernateException;
import org.hibernate.Query;
import org.hibernate.Session;
import org.hibernate.Transaction;

/**
 *
 * @author Jose Luis
 */
public class UsuarioDAO {

    private Session session;
    private Transaction transaction;

    public UsuarioDAO() {
    }

    protected void iniciaOperacion() throws HibernateException {
        session = HibernateUtil.getSessionFactory().openSession();
        transaction = session.beginTransaction();
    }

    protected Session getSession() {
        return session;
    }

    protected Transaction getTransaction() {
        return transaction;
    }

    protected void manejaExcepcion(HibernateException he) throws HibernateException {
        UsuarioDAO usuarioDAO = new UsuarioDAO() {
        };
        usuarioDAO.getTransaction().rollback();
        throw new HibernateException("Ocurrió un error en la base de datos", he);
    }

    public boolean insertarUsuario(Usuario user) {
        UsuarioDAO usuarioDAO = new UsuarioDAO() {
        };

        try {

            usuarioDAO.iniciaOperacion();

            usuarioDAO.getSession().save(user);
            usuarioDAO.getTransaction().commit();

            return true;

        } catch (HibernateException he) {
            usuarioDAO.manejaExcepcion(he);
            throw he;
        } finally {
            usuarioDAO.getSession().close();
        }
    }

    public Usuario selectUsuario(String login, String password) {
        Usuario usuario = null;
        UsuarioDAO usuarioDAO = new UsuarioDAO() {
        };

        usuarioDAO.iniciaOperacion();

        try {
            Query query = usuarioDAO.getSession().createQuery("FROM Usuario u WHERE u. login = :login AND u. password= :password");
            query.setParameter("login", login);
            query.setParameter("password", password);
            usuario = (Usuario) query.uniqueResult();

        } catch (HibernateException he) {
            usuarioDAO.manejaExcepcion(he);
            throw he;
        } finally {
            usuarioDAO.getSession().close();
        }
        return usuario;
    }

    public List<Usuario> selectAdministradores() {

        List<Usuario> listaAdministradores = null;
        UsuarioDAO usuarioDAO = new UsuarioDAO() {
        };
        String rol = "administrador";

        try {
            usuarioDAO.iniciaOperacion();

            Query query = usuarioDAO.getSession().createQuery("FROM Usuario u WHERE u.rol='" + rol + "'");

            listaAdministradores = query.list();
        } catch (HibernateException he) {
            usuarioDAO.manejaExcepcion(he);
            throw he;
        } finally {
            usuarioDAO.getSession().close();
        }

        return listaAdministradores;
    }

    public static void actualizaAdministrador(Usuario administrador) throws HibernateException {
        UsuarioDAO usuarioDAO = new UsuarioDAO() {
        };

        try {
            usuarioDAO.iniciaOperacion();
            usuarioDAO.getSession().update(administrador);
            usuarioDAO.getTransaction().commit();
        } catch (HibernateException he) {
            usuarioDAO.manejaExcepcion(he);
            throw he;
        } finally {
            usuarioDAO.getSession().close();
        }
    }

    public static void eliminaAdministrador(Usuario administrador) throws HibernateException {
        UsuarioDAO dummy = new UsuarioDAO() {
        };
        try {
            dummy.iniciaOperacion();
            dummy.getSession().delete(administrador);
            dummy.getTransaction().commit();
        } catch (HibernateException he) {

            throw he;
        } finally {
            dummy.getSession().close();
        }
    }

    public static Usuario getUsuario(String email) throws HibernateException {
        Usuario usuario = null;
        UsuarioDAO usuarioDAO = new UsuarioDAO() {
        };


        try {
            usuarioDAO.iniciaOperacion();
            Query query = usuarioDAO.getSession().createQuery("FROM Usuario u WHERE u. email = :email");
            query.setParameter("email", email);

            usuario = (Usuario) query.uniqueResult();

        } catch (HibernateException he) {
            usuarioDAO.manejaExcepcion(he);
            throw he;
        } finally {
            usuarioDAO.getSession().close();
        }

        return usuario;
    }

    public static Usuario getUsuarioLogin(String login) throws HibernateException {
        Usuario usuario = null;
        UsuarioDAO usuarioDAO = new UsuarioDAO() {
        };

        try {
            usuarioDAO.iniciaOperacion();
            Query query = usuarioDAO.getSession().createQuery("FROM Usuario u WHERE u. login = :login");
            query.setParameter("login", login);

            usuario = (Usuario) query.uniqueResult();

        } catch (HibernateException he) {
            usuarioDAO.manejaExcepcion(he);
            throw he;
        } finally {
            usuarioDAO.getSession().close();
        }

        return usuario;
    }
}
