/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package dao;

import entidad.Valoracion;
import java.util.List;
import org.hibernate.HibernateException;
import org.hibernate.Query;
import org.hibernate.Session;
import org.hibernate.Transaction;

/**
 *
 * @author Jose Luis
 */
public class ValoracionDAO {

    private Session session;
    private Transaction transaction;

    public ValoracionDAO() {
    }

    protected void iniciaOperacion() throws HibernateException {
        session = HibernateUtil.getSessionFactory().openSession();
        transaction = session.beginTransaction();
    }

    protected Session getSession() {
        return session;
    }

    protected Transaction getTransaction() {
        return transaction;
    }

    protected void manejaExcepcion(HibernateException he) throws HibernateException {
        ValoracionDAO valorDAO = new ValoracionDAO() {
        };
        valorDAO.getTransaction().rollback();
        throw new HibernateException("Ocurrió un error en la base de datos", he);
    }

    public boolean valorar(Valoracion valoracion) {

        ValoracionDAO valorDAO = new ValoracionDAO() {
        };
        try {

            valorDAO.iniciaOperacion();

            valorDAO.getSession().save(valoracion);
            valorDAO.getTransaction().commit();

            return true;

        } catch (HibernateException he) {
            valorDAO.manejaExcepcion(he);
            throw he;
        } finally {
            valorDAO.getSession().close();
        }
    }

    public static List<Valoracion> valoracionesProducto(int idProducto) throws HibernateException {

        List<Valoracion> valoracionesProducto = null;
        ValoracionDAO valorDAO = new ValoracionDAO();

        try {

            valorDAO.iniciaOperacion();
            Query query = valorDAO.getSession().createQuery("from Valoracion where idProducto = :idProducto");
            query.setParameter("idProducto", idProducto);

            valoracionesProducto = query.list();

        } catch (HibernateException he) {
            valorDAO.manejaExcepcion(he);
            throw he;
        } finally {
            valorDAO.getSession().close();
        }

        return valoracionesProducto;
    }

    public boolean valoradoPorCliente(int idCliente, int idProducto) {
        List<Valoracion> valoracionesProducto = null;
        ValoracionDAO valorDAO = new ValoracionDAO();
        boolean productoValorado = false;

        try {

            valorDAO.iniciaOperacion();
            Query query = valorDAO.getSession().createQuery("from Valoracion where idCliente = :idCliente and idProducto = :idProducto");
            query.setParameter("idCliente", idCliente);
            query.setParameter("idProducto", idProducto);
            valoracionesProducto = query.list();
            if (valoracionesProducto.size() != 0) {
                productoValorado = true;
            }

        } catch (HibernateException he) {
            valorDAO.manejaExcepcion(he);
            throw he;
        } finally {
            valorDAO.getSession().close();
        }
        return productoValorado;
    }
}
