/*
SQLyog Community v8.71 
MySQL - 6.0.10-alpha-community : Database - webcine
*********************************************************************
*/


/*!40101 SET NAMES utf8 */;

/*!40101 SET SQL_MODE=''*/;

/*!40014 SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;
/*!40111 SET @OLD_SQL_NOTES=@@SQL_NOTES, SQL_NOTES=0 */;
CREATE DATABASE /*!32312 IF NOT EXISTS*/`webcine` /*!40100 DEFAULT CHARACTER SET latin1 */;

USE `webcine`;

/*Table structure for table `categoria` */

DROP TABLE IF EXISTS `categoria`;

CREATE TABLE `categoria` (
  `idCategoria` int(11) NOT NULL AUTO_INCREMENT,
  `nombreCategoria` varchar(30) NOT NULL,
  `imagen` varchar(30) NOT NULL,
  PRIMARY KEY (`idCategoria`)
) ENGINE=InnoDB AUTO_INCREMENT=13 DEFAULT CHARSET=latin1;

/*Data for the table `categoria` */

insert  into `categoria`(`idCategoria`,`nombreCategoria`,`imagen`) values (6,'Terror','Terror.jpg'),(7,'Animacion','Animacion.jpg'),(8,'Ciencia Ficcion','CienciaFiccion.jpg'),(9,'Comedia','Comedia.jpg'),(10,'Oeste','Oeste.jpg'),(11,'Romantico','Romantico.jpg'),(12,'Musical','Musical.jpg');

/*Table structure for table `compra` */

DROP TABLE IF EXISTS `compra`;

CREATE TABLE `compra` (
  `idCompra` int(11) NOT NULL AUTO_INCREMENT,
  `fechaCompra` date NOT NULL,
  `estadoCompra` varchar(30) NOT NULL,
  `precio` float NOT NULL,
  `idCliente` int(11) NOT NULL,
  `metodoPago` int(11) NOT NULL,
  PRIMARY KEY (`idCompra`)
) ENGINE=InnoDB AUTO_INCREMENT=45 DEFAULT CHARSET=latin1;

/*Data for the table `compra` */

insert  into `compra`(`idCompra`,`fechaCompra`,`estadoCompra`,`precio`,`idCliente`,`metodoPago`) values (44,'2014-01-13','Enviado',31.7,2,1);

/*Table structure for table `metodopago` */

DROP TABLE IF EXISTS `metodopago`;

CREATE TABLE `metodopago` (
  `idMetodoPago` int(11) NOT NULL AUTO_INCREMENT,
  `tipoPago` varchar(30) NOT NULL,
  `coste` float NOT NULL,
  PRIMARY KEY (`idMetodoPago`)
) ENGINE=InnoDB AUTO_INCREMENT=5 DEFAULT CHARSET=latin1;

/*Data for the table `metodopago` */

insert  into `metodopago`(`idMetodoPago`,`tipoPago`,`coste`) values (1,'PayPal',1),(2,'Transferencia Bancaria',0),(3,'Tarjeta de Credito',2),(4,'Contrareembolso',3);

/*Table structure for table `producto` */

DROP TABLE IF EXISTS `producto`;

CREATE TABLE `producto` (
  `idProducto` int(11) NOT NULL AUTO_INCREMENT,
  `descripcion` varchar(1000) NOT NULL,
  `stock` int(11) NOT NULL,
  `imagen` varchar(30) NOT NULL,
  `nombreProducto` varchar(30) NOT NULL,
  `precio` float NOT NULL,
  `valoracion` float NOT NULL,
  `idCategoria` int(11) NOT NULL,
  PRIMARY KEY (`idProducto`)
) ENGINE=InnoDB AUTO_INCREMENT=73 DEFAULT CHARSET=latin1;

/*Data for the table `producto` */

insert  into `producto`(`idProducto`,`descripcion`,`stock`,`imagen`,`nombreProducto`,`precio`,`valoracion`,`idCategoria`) values (1,'La vida de Dave Seville (Jason Lee), un compositor sin éxito, es monótona y frustrante, hasta que se encuentra con tres ardillas (Alvin, Simon y Theodore) que vienen del bosque. Dave las expulsa de su casa al no encontrar natural que las ardillas hablen, pero cambia de opinión cuando las oye cantar y los invita a cantar sus letras. Dave acude a su discográfica para mostrar las ardillas a su jefe, pero este las engaña para que se queden con él.',5,'alvinylasardillas.jpg','Alvin y las ardillas',5,5,7),(2,'Shrek es una película de animación digital de 2001, dirigida por Andrew Adamson y Vicky Jenson. Está basada en en el libro infantil ilustrado Shrek!, de William Steig (1990). La película ganó el Oscar a la Mejor Película de Animación y participó en la selección oficial del Festival de Cannes de 2001. Shrek quiere decir susto en Idish, idioma previo al hebreo.',6,'shrek.jpg','Shrek',12.5,5,7),(44,'Ebenezer Scrooge (Jim Carrey) comienza las vacaciones de Navidad con su habitual actitud despreciativa y bruscos modales cuando habla con su fiel empleado Bob Cratchit (Gary Oldman) y con su alegre sobrino (Colin Firth). Pero cuando los espíritus de las Navidades pasadas, presentes y futuras lo llevan en un esclarecedor viaje que le revela verdades que él se resiste a ver, el viejo Scrooge finalmente deberá abrir su corazón y compensar años de rencor antes de que sea demasiado tarde... Adaptación del clásico de Charles Dickens, utilizando la misma técnica de animación que en \"Polar Express\" y \"Beowulf\".',6,'cuentodenavidad.jpg','Cuento de navidad',13.55,5,7),(45,'Rose, una joven madre (Radha Mitchell), trata de encontrar una cura para su única hija, enferma. Incapaz de resignarse al diagnóstico de los médicos que proponen internarla de forma permanente para su cuidado psiquiátrico, Rose huye con su hija hasta llegar a una ciudad aparentemente desértica...',7,'silenthill.jpg','Silent Hill',15.7,5,6),(46,'Nueva reedición de la clásica saga de terror sobre Freddy Krueger, un serial killer que aterroriza y mata a jóvenes durante sus sueños. En esta vuelta a los orígenes de la historia, el personaje de Freddy Krueger, hasta ahora casi siempre asociado al actor Robert Englund, es interpretado ahora por Jackie Earle Haley',8,'pesadillaenelmstreet.jpg','Pesadilla en Elm Street',16,5,6),(47,'Basada en un caso real de posesión que tuvo lugar en los suburbios de Washington. Regan es una niña de 12 años que vive con su madre y que se siente mal; sufre extraños síntomas, incluyendo la levitación y una fuerza sobrehumana. Los doctores intentan tratarla en vano, así que cuando se descartan las explicaciones médicas, su madre recurre a un sacerdote con estudios de psiquiatría. Éste se muestra convencido de que el mal ha rebasado lo físico y afecta a los espiritual. Una vez seguros de que la niña está poseida, junto a otro sacerdote decidirá practicar un exorcismo.',4,'elexorcista.jpg','El exorcista',11.2,5,6),(48,'Los Ángeles, año 2029. Las máquinas dominan el mundo. Los rebeldes que luchan contra ellas tienen como líder a John Connor, un hombre que nació en los años ochenta. Para acabar con la rebelión, las máquinas deciden enviar al pasado a un robot -Terminator- cuya misión será eliminar a Sarah Connor, la madre de John, e impedir así su nacimiento.',8,'terminator.jpg','Terminator',10.6,5,8),(49,'Spider-Man (El Hombre-Araña en Hispanoamérica) es una película estadounidense del 2002 dirigida por Sam Raimi, inspirada en el cómic homónimo creado por Stan Lee y Steve Ditko en 1962. Fue la segunda de la serie de películas de los superheroes de Marvel que iniciaría la película X-Men en el año 2000.',0,'spiderman.jpg','Spiderman',15.8,5,8),(50,'Batman Begins (titulada Batman inicia en Hispanoamérica y Batman comienza en República Dominicana) es una película estadounidense estrenada en 2005 basada en el superhéroe de DC Comics, Batman. Fue dirigida por Christopher Nolan y escrita por Nolan y David S. Goyer. En ella actúan Christian Bale en el papel protagonista de Bruce Wayne y Batman, además de Michael Caine, Gary Oldman, Liam Neeson, Katie Holmes, Cillian Murphy y Morgan Freeman.',5,'batmanbegins.jpg','Batman begins',12.9,5,8),(51,'Un amable policía sufre un día un trastorno de personalidad, volviéndose un ser completamente opuesto a como era antes. Comedia de los creadores de \"Algo pasa con Mary\" que obtuvo un gran éxito de taquilla en USA.',6,'yoyomismoeirene.jpg','Yo, yo mismo e Irene',14.5,5,9),(52,'Dos días antes de su boda, Doug (Justin Bartha) viaja en coche a Las Vegas con sus mejores amigos, Phil y Stu (Bradley Cooper y Ed Helms), y su futuro cuñado, Alan (Zach Galifianakis), para celebrar un fiestón de despedida. A la mañana siguiente, los tres amigos del novio se despiertan con una fuerte resaca y no recuerdan nada de lo sucedido durante la juerga nocturna. La suite del lujoso hotel está convertida en un basurero y el novio no aparece por ninguna parte. Sin ninguna pista de lo sucedido y con poco tiempo que perder, los tres deben intentar recordar sus malas decisiones de la noche anterior para averiguar dónde está Doug. Pero cuanto más empiezan a descubrir, más se dan cuenta de los problemas en los que están metidos.',5,'resaconenlasvegas.jpg','Resacon en las Vegas',11.4,5,9),(53,'Una legión de jóvenes inexpertos viven obsesionados con el sexo opuesto. Jim, uno de ellos, está desesperado porque todavía es virgen. Además, desde que sus padres le sorprendieron viendo películas pornográficas, su situación en casa ha empeorado, porque su bienintencionado padre pretende ocuparse de su educación sexual; en el colegio, las cosas no van mucho mejor: su relación con una chica, gracias a un programa de intercambio, tiene toda la pinta de fracasar. Así que su último recurso se llama Michelle, una integrante de la banda de música que resulta ser todo un prodigio.',6,'americanpie.jpg','American pie',12.5,5,9),(54,'Los protagonistas son tres cazadores de recompensas, en la búsqueda de un tesoro que ninguno de los tres truhanes puede localizar sin la ayuda de los otros dos. De esta forma, los tres hombres colaboran en apariencia, pero está bien claro que al final intentarán eliminarse mutuamente.',4,'elbuenoelfeoyelmalo.jpg','El bueno, el feo y el malo',11.5,5,10),(55,'Relata la historia de William Munny (Clint Eastwood), un pistolero viejo, viudo y acabado, que tiene dificultades para mantener a sus hijos. A pesar de estar retirado de su antigua vida como cruel forajido, se le presenta la oportunidad de sacar adelante a su familia haciendo un último trabajo, acompañado por un viejo socio y un joven e inexperto novato. La misión consiste en matar a dos hombres que le marcaron la cara a una prostituta en el pueblo de Big Whiskey. Pero el shérif \"Little Bill\" (Gene Hackman) estará dispuesto a todo para evitar que nadie cobre la recompensa que ofrecen las prostitutas en venganza por su compañera.',4,'sinperdon.jpg','Sin perdon',10.25,5,10),(56,'Dos cazadores de recompensas a la caza del mismo hombre deciden unir sus fuerzas para intentar encontrarlo juntos, aunque las motivaciones de ambos resultarán completamente diferentes. Spaguetti-Western, uno de los mayores éxitos del cine español de todos los tiempos -en coproducción con Italia y Alemania-. Su título original (Per qualche dollaro in più, For a Few Dollars More) ya sugiere que es la continuación natural de \"Por un puñado de dólares\" (Per un pugno di dollari, 1964), dirigida también por Leone un año antes.',2,'lamuerteteniaunprecio.jpg','La muerte tenia un precio',11.4,5,10),(57,'En el verano de 1940 Allie (Rachel McAdams) conoció a Noah (Ryan Gosling) y ambos se enamoraron. Ahora, un anciano le cuenta a su compañera de asilo la historia de amor de estos jóvenes mientras lee el diario de Noah.',3,'eldiariodenoa.jpg','El diario de Noa',14.5,5,11),(58,'Jack (DiCaprio), un joven artista, gana en una partida de cartas un pasaje para viajar a América en el Titanic, el trasatlántico más grande y seguro jamás construido. A bordo conoce a Rose (Kate Winslet), una joven de una buena familia venida a menos que va a contraer un matrimonio de conveniencia con Cal (Billy Zane), un millonario engreído a quien sólo interesa el prestigioso apellido de su prometida. Jack y Rose se enamoran, pero el prometido y la madre de ella ponen todo tipo de trabas a su relación. Mientras, el gigantesco y lujoso trasatlántico se aproxima hacia un inmenso iceberg...',8,'titanic.jpg','Titanic',15.6,5,11),(59,'\"Tres metros sobre el cielo\" es un drama romántico adolescente que narra la historia de dos jóvenes que pertenecen a mundos opuestos que inician una relación. Babi (María Valverde) es una chica de clase media-alta que está educada en la bondad, en la inocencia y en las normas; Hache (Mario Casas) es un chico guapo, rebelde, impulsivo, inconsciente, aficionado al riesgo y al peligro, enzarzado en un sinfín de peleas y carreras ilegales de motos, al límite del sentido común.',5,'3metrossobreelcielo.jpg','3 metros sobre el cielo',13.4,5,11),(60,'Spider-Man 2 (El Hombre Araña 2 en Hispanoamérica) es una película de superhéroes estadounidense de 2004 dirigida por Sam Raimi, escrita por Alvin Sargent y desarrollada por Alfred Gough, Miles Millar y Michael Chabon. Es la segunda película en la franquicia Spider-Man basada en el personaje ficticio de Marvel Comics Spider-Man. Como protagonistas estuvieron de vuelta Tobey Maguire como Peter Parker, Kirsten Dunst como Mary Jane Watson y James Franco como Harry Osborn. Se desarrolla dos años después del film original. Se centra en Peter luchando con su vida personal y como Spider-Man. El villano del film es el doctor Otto Octavius (Alfred Molina), que se vuelve loco después de un experimento fallido resultante con la muerte de su esposa. Usando sus tentáculos mecánicos, Otto es apodado \"Doctor Octopus\" y aterroriza Nueva York.',4,'spiderman2.jpg','Spiderman 2',12.9,5,8),(61,'Los juguetes de Andy, un niño de 6 años, temen que haya llegado su hora y que un nuevo regalo de cumpleaños les sustituya en el corazón de su dueño. Woody, un vaquero que ha sido hasta ahora el juguete favorito de Andy, trata de tranquilizarlos hasta que aparece Buzz Lightyear, un héroe espacial dotado de todo tipo de avances tecnológicos. Woody es relegado a un segundo plano. Su constante rivalidad se transformará en una gran amistad cuando ambos se pierden en la ciudad sin saber cómo volver a casa.',12,'Toy-Story-DVD.jpg','Toy Story',12,5,7),(62,'Johnny Castle (Patrick Swayze) es un experto profesor de baile y un amante consumado. Baby Houseman (Jennifer Grey) es una idealista e inocente adolescente. Ambos coinciden en un hotel de montaña durante las vacaciones de verano: ella como huésped, él cómo profesor y bailarín del centro. Cuando la joven ve al bailarín, queda prendada de él a pesar de las diferencias sociales entre ambos y se forma entre los dos una atmósfera cómplice a través del baile. Cuando una situación comprometida le aleja de su padre, Baby y Johnny inician un camino juntos en el que ella descubre el sexo y él el amor y la confianza.\r\nLa película, que se centra en los principios de la década de los 60, resalta las diferencias entre la clase trabajadora y la media-alta norteamericana, el comienzo de la ruptura de las «normas sociales» y el despertar de la libertad sexual auspiciada por una música más cálida e inspiradora.',4,'dirtydancing.jpg','Dirty Dancing',10.5,5,12),(63,'Durante unas vacaciones de Navidad, los jóvenes Troy y Gabriella (dos adolescentes en principo con pocas cosas en común) se conocen. Ambos descubren su interés mutuo por la música durante un concurso de karaoke, y deciden presentarse al casting del musical del instituto.',5,'highschoolmusical.jpg','High School Musical',15.3,5,12),(65,'Sophie Sheridan (Amanda Seyfried) es una chica de veinte años que vive junto a su madre (Meryl Streep) en una isla griega. Está a punto de casarse y quiere descubrir una cosa: quién es su padre. Por ello, y sin que su madre lo sepa, decide invitar al evento a tres hombres con los que ella tuvo una aventura o llamada \"affair\" en ingles: Sam Carmichael (Pierce Brosnan), Harry Brigth (Colin Firth) y Bill Anderson (Stellan Skarsgård).',3,'mammamia.jpg','Mamma Mia',15.6,5,12),(66,'Remake del musical \"underground\" de culto de John Waters. Tracy Turnblad (Nikki Blonsky), una chica grande, con un gran peinado y un corazón aún mayor, tiene solamente una pasión: bailar. Su sueño es aparecer en \"El Show de Corny Collins\", el programa de baile televisado más codiciado de Baltimore. Tracy parece perfecta para el programa, a no ser por un problema no tan pequeño: no cabe. Su figura generosa siempre la ha apartado de los grupos a la moda, cosa que le recuerda continuamente su amante pero excesivamente sobre protectora madre y de generosa figura, Edna. Esto no detiene a Tracy porque si existe alguna una cosa que esta gran chica sabe, es que ella nació para bailar...',4,'hairspray.jpg','Hairspray',15.2,5,12),(67,'El pececillo Nemo, que es hijo único, es muy querido y protegido por su padre. Después de ser capturado en un arrecife australiano va a parar a la pecera de la oficina de un dentista de Sidney. Su tímido padre emprenderá una peligrosa aventura para rescatarlo. Pero Nemo y sus nuevos amigos tienen también un astuto plan para escapar de la pecera y volver al mar.',5,'buscandoanemo.jpg','Buscando a Nemo',23.2,5,7),(68,'En el año 2700, en un planeta Tierra devastado y sin vida, tras cientos de solitarios años haciendo aquello para lo que fue construido -limpiar el planeta de basura- el pequeño robot WALL•E (acrónimo de Waste Allocation Load Lifter Earth-Class) descubre una nueva misión en su vida (además de recolectar cosas inservibles) cuando se encuentra con una moderna y lustrosa robot exploradora llamada EVE. Ambos viajarán a lo largo de la galaxia y vivirán una emocionante e inolvidable aventura...',6,'wall-e.jpg','Wall-e',12.5,5,7),(69,'Monsters Inc. es la mayor empresa de miedo del mundo, y James P. Sullivan es uno de sus mejores empleados. Asustar a los niños no es un trabajo fácil, ya que todos creen que los niños son tóxicos y no pueden tener contacto con ellos. Pero un día una niña se cuela sin querer en la empresa, provocando el caos.',5,'monstruossa.jpg','Monstruos S.A.',21.3,5,7),(70,'Carl Fredricksen es un viudo vendedor de globos de 78 años que, finalmente, consigue llevar a cabo el sueño de su vida: enganchar miles de globos a su casa y salir volando rumbo a América del Sur. Pero ya estando en el aire y sin posibilidad de retornar Carl descubre que viaja acompañado de Russell, un explorador que tiene ocho años y un optimismo a prueba de bomba.',3,'up.jpg','UP',14.6,5,7),(71,'Z-4196 es tan sólo una neurótica hormiga obrera macho, una más entre sus millones de hermanas. Después de bailar con la princesa Bala, se enamora de ella, pero se trata de un amor imposible. Convence, sin embargo, a un amigo para que le ceda su puesto en un desfile militar para poder estar cerca de la princesa. La excavación de un nuevo túnel es supervisada por el general Mandible, una hormiga ambiciosa que convence a la reina de la necesidad de enviar al batallón del hormiguero a la guerra contra las termitas. Y en ese batallón se encuentra el asustadizo y cobarde Z...',3,'antz.jpg','Antz',14.5,5,7),(72,'Homer debe salvar al mundo de una catástrofe que él mismo ha provocado. Todo comienza con Homer, su nueva mascota, un cerdo, y un silo lleno de excrementos que tiene una fuga, una combinación que desencadena un desastre distinto a todo lo que Springfield haya experimentado jamás. Mientras Marge está indignada por la monumental metedura de pata de su patán marido, una turba vengativa cae sobre el hogar de los Simpson...',6,'lossimpsons.jpg','Los Simpsons',16.2,5,7);

/*Table structure for table `productoscompra` */

DROP TABLE IF EXISTS `productoscompra`;

CREATE TABLE `productoscompra` (
  `idProducto` int(11) NOT NULL,
  `idCompra` int(11) NOT NULL,
  `cantidad` int(11) NOT NULL,
  PRIMARY KEY (`idProducto`,`idCompra`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

/*Data for the table `productoscompra` */

insert  into `productoscompra`(`idProducto`,`idCompra`,`cantidad`) values (51,44,1),(72,44,1);

/*Table structure for table `usuario` */

DROP TABLE IF EXISTS `usuario`;

CREATE TABLE `usuario` (
  `idUsuario` int(11) NOT NULL AUTO_INCREMENT,
  `nombre` varchar(30) NOT NULL,
  `apellidos` varchar(30) NOT NULL,
  `dni` varchar(9) NOT NULL,
  `direccion` varchar(30) NOT NULL,
  `localidad` varchar(30) NOT NULL,
  `ciudad` varchar(30) NOT NULL,
  `codigoPostal` int(11) NOT NULL,
  `pais` varchar(30) NOT NULL,
  `login` varchar(30) NOT NULL,
  `password` varchar(30) NOT NULL,
  `telefono` int(11) DEFAULT NULL,
  `email` varchar(30) NOT NULL,
  `rol` varchar(13) NOT NULL,
  PRIMARY KEY (`idUsuario`)
) ENGINE=InnoDB AUTO_INCREMENT=5 DEFAULT CHARSET=latin1;

/*Data for the table `usuario` */

insert  into `usuario`(`idUsuario`,`nombre`,`apellidos`,`dni`,`direccion`,`localidad`,`ciudad`,`codigoPostal`,`pais`,`login`,`password`,`telefono`,`email`,`rol`) values (1,'Administrador','Admin','123456789','xxxx','xxxx','xxxx',12345,'España','administrador','administrador',123456789,'webcine.jdelho@gmail.com','administrador'),(2,'Cliente','Cli','123456789','xxxx','xxxx','xxxx',13500,'España','cliente','cliente',123456789,'cliente.webcine@gmail.com','cliente');

/*Table structure for table `valoracion` */

DROP TABLE IF EXISTS `valoracion`;

CREATE TABLE `valoracion` (
  `valoracion` float NOT NULL,
  `idProducto` int(11) NOT NULL,
  `idCliente` int(11) NOT NULL,
  PRIMARY KEY (`idProducto`,`idCliente`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1;

/*Data for the table `valoracion` */

/*!40101 SET SQL_MODE=@OLD_SQL_MODE */;
/*!40014 SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS */;
/*!40014 SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS */;
/*!40111 SET SQL_NOTES=@OLD_SQL_NOTES */;
